#ifndef _LOGIC_16
#define _LOGIC_16

#define NOT_rm16 \
Read_rm16(op1_16); \
aux16=~op1_16; \
Write_rm16(aux16) \

#define OR_r16_rm16 \
DecodeModRM; \
Read_rm16(op2_16); \
op1_16=Read_Reg16(Regop); \
aux16=op1_16|op2_16; \
Write_Reg16(Regop,aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define OR_rm16_r16 \
DecodeModRM; \
Read_rm16(op1_16); \
op2_16=Read_Reg16(Regop); \
aux16=op1_16|op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define OR_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16|op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define OR_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16|op2_8; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define OR_AX_imm16 \
op2_16=CPUReadMemory16(); \
aux16=AX|op2_16; \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF; \
AX=aux16 \

#define AND_r16_rm16 \
DecodeModRM; \
Read_rm16(op2_16); \
op1_16=Read_Reg16(Regop); \
aux16=op1_16&op2_16; \
Write_Reg16(Regop,aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define AND_rm16_r16 \
DecodeModRM; \
Read_rm16(op1_16); \
op2_16=Read_Reg16(Regop); \
aux16=op1_16&op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define AND_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16&op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define AND_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16&op2_8; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define AND_AX_imm16 \
op2_16=CPUReadMemory16(); \
aux16=AX&op2_16; \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF; \
AX=aux16 \

#define XOR_r16_rm16 \
DecodeModRM; \
Read_rm16(op2_16); \
op1_16=Read_Reg16(Regop); \
aux16=op1_16^op2_16; \
Write_Reg16(Regop,aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define XOR_rm16_r16 \
DecodeModRM; \
Read_rm16(op1_16); \
op2_16=Read_Reg16(Regop); \
aux16=op1_16^op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define XOR_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16^op2_16; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define XOR_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16^op2_8; \
Write_rm16(aux16); \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define XOR_AX_imm16 \
op2_16=CPUReadMemory16(); \
aux16=AX^op2_16; \
ClrOF; \
ClrCF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF; \
AX=aux16 \

#define CMP_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16-op2_16; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define CMP_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16-op2_8; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#endif
