#ifndef _LOGIC_8
#define _LOGIC_8

#define NOT_rm8 \
Read_rm8(op1_8); \
aux8=~op1_8; \
Write_rm8(aux8) \

#define OR_r8_rm8 \
DecodeModRM; \
Read_rm8(op2_8); \
op1_8=Read_Reg8(Regop); \
aux8=op1_8|op2_8; \
Write_Reg8(Regop,aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define OR_rm8_r8 \
DecodeModRM; \
Read_rm8(op1_8); \
op2_8=Read_Reg8(Regop); \
aux8=op1_8|op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define OR_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8|op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define OR_AL_imm8 \
op2_8=CPUReadMemory8(); \
aux8=AL|op2_8; \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF; \
AL=aux8 \

#define AND_r8_rm8 \
DecodeModRM; \
Read_rm8(op2_8); \
op1_8=Read_Reg8(Regop); \
aux8=op1_8&op2_8; \
Write_Reg8(Regop,aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define AND_rm8_r8 \
DecodeModRM; \
Read_rm8(op1_8); \
op2_8=Read_Reg8(Regop); \
aux8=op1_8&op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define AND_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8&op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define AND_AL_imm8 \
op2_8=CPUReadMemory8(); \
aux8=AL&op2_8; \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF; \
AL=aux8 \

#define XOR_r8_rm8 \
DecodeModRM; \
Read_rm8(op2_8); \
op1_8=Read_Reg8(Regop); \
aux8=op1_8^op2_8; \
Write_Reg8(Regop,aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define XOR_rm8_r8 \
DecodeModRM; \
Read_rm8(op1_8); \
op2_8=Read_Reg8(Regop); \
aux8=op1_8^op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define XOR_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8^op2_8; \
Write_rm8(aux8); \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define XOR_AL_imm8 \
op2_8=CPUReadMemory8(); \
aux8=AL^op2_8; \
ClrOF; \
ClrCF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF; \
AL=aux8 \

#define CMP_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8-op2_8; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#endif
